/*
 *========================================================================
 * See copyright in copyright.h and the accompanying file COPYING
 *========================================================================
 */

/* To enable large file support */
#define _FILE_OFFSET_BITS 64

/* Lots of useful stuff we don't need for simple template */
#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <sys/time.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <math.h>
#include <limits.h>

/*
 *========================================================================
 * Useful defines.  Some are redundant (e.g. PI with M_PI).
 *========================================================================
 */

#define STDIN	stdin
#define STDOUT	stdout
#define STDERR	stderr
#define YES	1
#define NO	0
#define PI      3.141592653589793238462643
#define K       1024
#define LINE    80
#define PAGE    4096
#define M       1048576
#define M_2     2097152

/*
 * For reasons unknown and unknowable, free() doesn't null the pointer
 * it frees (possibly because it is called by value!)  Nor does it return
 * a success value.  In fact, it is just a leak or memory corruption waiting
 * to happen.  Sigh.
 *
 * nullfree frees and sets the pointer it freed back to NULL.  This let's
 * one e.g. if(a) nullfree(a) to safely free a IFF it is actually a pointer,
 * and let's one test on a in other ways to avoid leaking memory.
 */
#define nullfree(a) {free(a);a = 0;}

/*
 * This is how one gets a macro into quotes; an important one to keep
 * in all program templates.
 */
#define _QUOTEME(x) #x
#define QUOTEME(x) _QUOTEME(x)


 /*
  *========================================================================
  * Subroutine Prototypes.  Fill in yours below or organize them any
  * way you like. Note that these should correspond to objects in the
  * LIBRARY, not the toplevel application!
  *========================================================================
  */


 /*
  *========================================================================
  *                           Global Variables
  *
  * The primary control variables, in alphabetical order, with comments.
  * There may be none at all, but many programs are easier to write with
  * a bit of memory shared with a toplevel application.  Alternative good
  * practice is to make all calls to the library functions pass all
  * data as arguments to the functions.  Sometimes this is easy and natural
  * and sometimes it isn't.
  *========================================================================
  */
 int verbose;           /* This controls verbosity and is always needed. */
  
